class Node
{
	int val;
	Node next;

	public Node(int val, Node next)
	{
		this.val = val;
		this.next = next;
	}

	public void print()
	{
		System.out.print(val + " ");
		if (next != null)
			next.print();
	}

	static Node fromArgs(String[] args)
	{
		Node head = null;
		for (int i = args.length - 1; i >= 0; i--) {
			head = new Node(Integer.parseInt(args[i]), head);
		}
		return head;
	}
}


public class Reverse
{
    ////////////////////////////////////////// Reverse

	static Node reverse(Node x)
	{ 
		Node t, y = x, r = null;
		while (y != null) { 
			t = y.next; 
			y.next = r; 
			r = y; 
			y = t; 
		}
		return r;
	}

	static Node reverse_helper(Node x, Node accumulator)
	{
		if (x == null)
			return accumulator;

		Node tail = x.next;
		x.next = accumulator;

		return reverse_helper(tail, x);
	}

	static Node reverse_rec(Node x)
	{
		return reverse_helper(x, null);		
	}


    ////////////////////////////////////////// Main

	public static void main(String[] args)
	{
		Node list = Node.fromArgs(args);
		list = reverse_rec(list);
		if (list != null)
			list.print();
		System.out.println();
	}
}
